#!/usr/bin/perl -i
#
#           
#    %     ,
#         
#  %   $EAdd

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#        Retract on layer change  
#        ,      Gcode
#  Only retract when crossing perimeters   
#       Custom G-code,   After layer change G-code 
#  Gcode: G92 E0;
#        
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

# G1 Z ,    ,      
#  G1 Z, 
#G1 E4.00000  -4    ,   3   
#   G1 E4.0000  G92 E0,    
# G92 E0 -   
# G92 E0 -    

#      
# perl -d d:\Reverse_script.pl d:\Etalon.gcode

#       Notepad++,    
# ->_,      :
# C:\Strawberry\perl\bin\perl.exe -d "$(FULL_CURRENT_PATH)" D:\Etalon.gcode
#            
#  ,      Perl  

#       
# DB<1>b num   num  ,     		152
# DB<2>c             
# DB<3>s	       

use strict;
use warnings;
use Data::Dumper;

my $HANDLE=@ARGV[0]; 					#    13 ,    ARGV[0], ..    print(length(@ARGV[0]));
										#  print($HANDLE);          @ARGV[0]

my $LayerNumWhenScriptStart=35;			#        G-code,    1        2 
my $SearchValue = "G92 E0";				#    ,      
									
my $ArraySSize= 0;						#      @Strings
my $ArrayESize= 0;						#      @E_values

#       [],      ,      1,  (),       0
my @Strings=();							#  
my @E_values=();						#    E
my @E_add_values=();					#     E
																	
my $E_value= 0.00000;
my $AfterE='';							#         E
my $EAdd=50;							# ***   %              $E_value
my $Retract=0;							#  

my $FilePos=0;							#      
my $FilePosNext=0;						#        
my $CharPos=0;							#   E   
my $String='';							#  
my $SumStrings='';						#    ,          ,    
my $EriserString='';					#             
my $SpacersNum=0;						#      $EriserString

my $G1Z =0;								# 
my $RetractCount=0;
my $i=0;
my $i1=0;
my $NumRun=0;							#          ,        

my $tmp1;
my $tmp2;

open FILE, "+< $HANDLE";
print("File opened \n");

$LayerNumWhenScriptStart++;				#   "G1 Z",    

while (<FILE>) 
{ #       
	if (/G1 Z/)
		{
		$G1Z++;							#     "G1 Z"
		$RetractCount=0;
		$NumRun=0;
		$FilePos=0;
		$SumStrings='';
		$ArraySSize=0;
		$ArrayESize=0;
		}
	if(/$SearchValue/) 					#     "G92 E0"
		{
		$RetractCount++;
		}
#______________________________________________________________________________________________________________________________________________________
#         
#______________________________________________________________________________________________________________________________________________________
	if(($G1Z>$LayerNumWhenScriptStart) && ($RetractCount==1)) 					#     ,     Z,
																				#      .
																				#     .
																				#     2 
		{
		$String=$_;							#   
		push(@Strings, $String);
		$ArraySSize++;						#     @Strings  1   ;  
		#print ("Layer num = ($G1Z-1) \nArraySSize = $ArraySSize  \n");
			if($FilePos==0)					#       
				{
				$FilePos=tell(FILE);
				$FilePos= $FilePos-length($String)-1;
				}
		if(/G1/ && /E/)		#  ,    
			{
			$CharPos=index($String, 'E')+1;
			$E_value=substr($String,$CharPos,length($String));
			$E_value=$E_value+0;								#       ,     
			#$E_value =sprintf("%s", $E_value);					#        string
			#print("E_value =$E_value \n");
			push(@E_values, $E_value);
			$ArrayESize++;										#     @E_values  1  ;  
			#print ("Layer num = $G1Z-1 \nArrayS = $ArraySSize  \nArrayE = $ArrayESize \n");
			if ($ArrayESize>=2)									#   ,    ,      %
				{
				$tmp1=@E_values[$ArrayESize-1];					#         @E_values
				$tmp2=@E_values[$ArrayESize-2];					#         @E_values
				
				$tmp1 ={$tmp1};									#        
				$tmp1 =Dumper $tmp1;							#   E       "$VAR1 ={'4'=> undef};"
				$i1=index($tmp1, '\'')+1;						#      
				$tmp1 =substr($tmp1,$i1,length($tmp1)-$i1);
				$i1=index($tmp1, '\'');
				$tmp1 =substr($tmp1, 0, $i1);
				
				$tmp2 ={$tmp2};									#        
				$tmp2 =Dumper $tmp2;							#   E       "$VAR1 ={'4'=> undef};"
				$i1=index($tmp2, '\'')+1;						#      
				$tmp2 =substr($tmp2,$i1,length($tmp2)-$i1);
				$i1=index($tmp2, '\'');
				$tmp2 =substr($tmp2, 0, $i1);
				#print("tmp1=$tmp1   tmp2=$tmp2\n");
				$Retract=$tmp2-$tmp1;							#   
				$tmp1=$tmp1-$tmp2;
				#print("E_add=$tmp1\n");
				push(@E_add_values, $tmp1);
				}
			}
		}
#______________________________________________________________________________________________________________________________________________________
#    @E_add_values      % $EAdd,   $E_value,       
#______________________________________________________________________________________________________________________________________________________
	if(($G1Z>$LayerNumWhenScriptStart) && ($RetractCount==2) && ($NumRun==0)) 	#    ,   
																				#       
																				#        
		{
		$NumRun=1;								#        1   
		$FilePosNext=tell(FILE);				#      ,      
		
		$String="G92 E0\n";						# ..  $RetractCount==2  ,           
		push(@Strings, $String);
		$ArraySSize++;
		
		#for($i=0;$i<=$ArrayESize-2;$i++)					# !!!!    
		#	{
		#	$tmp2=@E_add_values[$i];						#         @E_add_values
		#	$tmp2 ={$tmp2};									#        
		#	$tmp2 =Dumper $tmp2;							#   E       "$VAR1 ={'4'=> undef};"
		#	$CharPos=index($tmp2, '\'')+1;					#      
		#	$tmp2 =substr($tmp2,$CharPos,length($tmp2)-$CharPos);
		#	$CharPos=index($tmp2, '\'');
		#	$tmp2 =substr($tmp2, 0, $CharPos);
		#	print("\nE_add_last=$tmp2\n");
		#	}
		
		#      @E_values,     
		$E_value=@E_values[0];								#        @E_values
		$E_value ={$E_value};								#        
		$E_value =Dumper $E_value;							#   E       "$VAR1 ={'4'=> undef};"
		$CharPos=index($E_value, '\'')+1;					#      
		$E_value =substr($E_value,$CharPos,length($E_value)-$CharPos);
		$CharPos=index($E_value, '\'');
		$E_value =substr($E_value, 0, $CharPos);
		$E_value = $E_value +0;
		if($G1Z>3)
					{
					print("E_value=$E_value\n");
					}
		#print("\nE_value=$E_value\n");
		
		for($i=1;$i<=$ArrayESize-1;$i++)					#     
			{
			if ($i!=$ArrayESize-1)
				{
				#     @E_add_values
				$tmp2=shift(@E_add_values);						#         @E_add_values
				$tmp2 ={$tmp2};									#        
				$tmp2 =Dumper $tmp2;							#   E       "$VAR1 ={'4'=> undef};"
				$CharPos=index($tmp2, '\'')+1;					#      
				$tmp2 =substr($tmp2,$CharPos,length($tmp2)-$CharPos);
				$CharPos=index($tmp2, '\'');
				$tmp2 =substr($tmp2, 0, $CharPos);
				
				#    %   $EAdd
				$tmp2=$tmp2+$tmp2/100*$EAdd;
				
				#   $E_value  $tmp2
				$E_value=$E_value+$tmp2;
				@E_values[$i]=$E_value;							#      
				}
			else
				{
				$tmp2=shift(@E_add_values);						#      ,     ,       
				$E_value=$E_value-$Retract;
				@E_values[$i]=$E_value;							#      
				}
			}
		
#______________________________________________________________________________________________________________________________________________________	
#       X, Y  E     
#______________________________________________________________________________________________________________________________________________________	
		for($i=0;$i<=($ArraySSize-1);$i++)		#  ,       E
			{
			$String = shift(@Strings);			#       @Strings,  
			#print ("String =$String");
			
			if (index($String, 'E')==(-1))		#          
				{
				substr($SumStrings,length($SumStrings),length($String),"$String");
				#print ("SumStrings =$SumStrings");
				}
			else								#   ,    E
				{
				if (index($String, 'G1')!=-1)	#     'G1'
					{
					$CharPos=index($String, 'E')+1;
					$E_value=substr($String,$CharPos,length($String));
					$AfterE= $E_value;			
					$CharPos=index($AfterE, ' ');
					$AfterE=substr($AfterE,$CharPos,length($AfterE));				
					#print ("E_value =$E_value\nAfterE =$AfterE\n");
					$i1 =index($AfterE, ' ');
					if ($i1!=-1) 											#   $AfterE,     ".00000"      
						{
						$AfterE= substr($AfterE,$i1,length($AfterE)-$i1);
						}
					#$E_value = $E_values[$i1];								#        ;  ,     n/r/ jlyjdhtvtyyj
					$E_value =shift(@E_values);								#         @E_values,     1
					$E_value ={$E_value};									#        
					$E_value =Dumper $E_value;								#   E       "$VAR1 ={'4'=> undef};"
					$i1=index($E_value, '\'')+1;							#       $E_value
					$E_value =substr($E_value,$i1,length($E_value)-$i1);
					$i1=index($E_value, '\'');
					$E_value =substr($E_value, 0, $i1);
					#print ("E_value =$E_value\nAfterE =$AfterE\n");
					
					#   $E_value        5 
					$CharPos=index($E_value, '.')+1;
					$CharPos=$CharPos+5;
					$E_value=substr($E_value,0,$CharPos);
					#print ("E_value =$E_value\nAfterE =$AfterE\n");
					
					#     $E_value= $E_value + $AfterE      $AfterE      $E_value
					substr($E_value,length($E_value),length($AfterE),$AfterE);						#     E
					#print ("E_value =$E_value\nAfterE =$AfterE\n");
					$CharPos=index($String, 'E')+1;
					substr($String,$CharPos,length($String)-1,$E_value);							#    
					#print ("String =$String\n");
					#$SumStrings=$SumStrings+$String;	#  ,    
					substr($SumStrings,length($SumStrings),length($String),"$String");
					#print $SumStrings;
					}
				else							#     
					{
					substr($SumStrings,length($SumStrings),length($String),"$String");
					}
				}
			#print ("SumString = $SumStrings \n");
			if ($i==$ArraySSize-1)								#    ,      ";"   ,
																#          
				{
				#$SpacersNum=$FilePosNext-$FilePos-6;
				$SpacersNum=$FilePosNext-$FilePos-1;
				#print ("SpacersNum = $SpacersNum\nFilePos = $FilePos\nFilePosNext = $FilePosNext\n");
				$SpacersNum=$SpacersNum-length($SumStrings)-1;	#   ,        
				$i1 = length($SumStrings)-1;
				#print ("SpacersNum = $SpacersNum\nlength(SumStrings)-1 = $i1\n");
				$EriserString=';';
				for($i1=1;$i1<=$SpacersNum;$i1++)				#  - 
					{
					substr($EriserString,length($EriserString),1," ");
					}
				substr($SumStrings,length($SumStrings)-1,length($EriserString),$EriserString);
				}				
			}
		#print ("SumString = $SumStrings \n");
		seek(FILE,$FilePos,0);									#         
		syswrite(FILE, $SumStrings, length($SumStrings) );		#       	
		seek(FILE,$FilePosNext,0);								#          
		#splice(@Strings, $ArraySSize-1, $ArraySSize);			#    
		#splice(@E_values, $ArrayESize-1, $ArrayESize);
		}
}